#ifndef __MML_H__
#define __MML_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "../libgba/gba.h"

//---------------------------------------------------------------------------
#define MML_MAX_CNT					4
#define MML_TEMPO_MAGIC				(60 * 60 * 4)
#define MML_FLEQ_REST				0
#define MML_FLEQ_ERR				9000
#define MML_FLEQ_CTL				9001
#define MML_FLEQ_END				9002


enum {
	TOKEN_C             = 1,
	TOKEN_CS,
	TOKEN_D,
	TOKEN_DS,
	TOKEN_E,
	TOKEN_F,
	TOKEN_FS,
	TOKEN_G,
	TOKEN_GS,
	TOKEN_A,
	TOKEN_AS,
	TOKEN_B,
	TOKEN_BS,        // = 13

	TOKEN_REST          = 50,
	TOKEN_OCTAVE,
	TOKEN_OCTAVE_UP,
	TOKEN_OCTAVE_DOWN,
	TOKEN_RELATIVE_X,
	TOKEN_LEN,
	TOKEN_PERIOD,
	TOKEN_TEMPO,
	TOKEN_SHARP,
	TOKEN_FLAT,
	TOKEN_VOLUME,
	TOKEN_TONE,
	TOKEN_ENVELOP_STEP,
	TOKEN_SWEEP,
	TOKEN_CANMA,
	TOKEN_ED,
	TOKEN_ERR,
};


//---------------------------------------------------------------------------

typedef struct {
	char* pStr;				// MMLf[^
	char* pCur;				// Ăꏊ
	char* pPrev;			// PȌĂꏊ
	u16   tempo;			// ȑŜ̃e|il: T120j
	u16   len;				// ̒iL1: S  L64: 64j
	u16   lenOnce;			// ̒iʎwpj
	u16   lenCtdn;			// ̃JEg_Ep
	s16   octave;			// IN^[uiO3-O8j
	u16   fleq;				// gi0: xj
	s16   volume;			// ʁi0-15Al: 7j
	s16   tone;				// Fi0- 3Al: 3j
	bool  isRelativeX;		// '<'1IN^[u UP [h
	bool  isRepeat;			// s[g̗L
	bool  isPlay;			// Đ̗L
	bool  isErr;			// G[L
	s16   envelopStep;		// ̌i0-7Al: 7A傫قǌɎԂB0͌Ȃj
	s16   sweepDir;			// XEB[v̑il: FALSEAFALSEȂdecATRUEȂINCj
	s16   sweepShift;		// XEB[v̗ʁi0-7Al: 0j
	s16   sweepTime;		// XEB[v̎ԁi0-7Al 0j
} ST_MML;


//---------------------------------------------------------------------------
EWRAM_CODE void MmlInit(void);
IWRAM_CODE void MmlInitCh(u16 ch, char* pStr);

IWRAM_CODE void MmlPlay(void);
IWRAM_CODE void MmlPlayCh1(void);
IWRAM_CODE void MmlPlayCh2(void);
IWRAM_CODE void MmlPlayCh4(void);
IWRAM_CODE void MmlStop(void);

IWRAM_CODE u16  MmlGetFleq(u16 ch);
IWRAM_CODE u16  MmlGetToken(u16 ch);

IWRAM_CODE bool MmlIsOctave(s16 octave);
IWRAM_CODE bool MmlIsTone(s16 tone);
IWRAM_CODE bool MmlIsEnvelopStep(s16 envelopStep);
IWRAM_CODE bool MmlIsSweepTime(s16 num);
IWRAM_CODE bool MmlIsSweepShift(s16 num);
IWRAM_CODE bool MmlIsLen(s16 num);
IWRAM_CODE bool MmlIsVolume(s16 num);
IWRAM_CODE bool MmlIsTempo(s16 num);
IWRAM_CODE bool MmlIsNumber(char chr);
IWRAM_CODE bool MmlIsEnd(void);

IWRAM_CODE void MmlDownOctave(u16 ch);
IWRAM_CODE void MmlUpOctave(u16 ch);

IWRAM_CODE void MmlIntr(void);
IWRAM_CODE void MmlIntrSub(u16 ch);



#ifdef __cplusplus
}
#endif
#endif


/*
-------------------------------------------------------------------------------
TEhCu  2004/9/16 Shinya Sato

g

1.܂͂߂ InitMusic() ĂяoďB
2.uh~xh~x݁vtꍇɂ́A
	Music1("CDERCDER");
	ƂB
	ȂAs[gĂقƂɂ Music1Repeat("CDERCDR"); ƂB
3. y~߂Ƃɂ Music1Stop();

Music1 ̂قɁAMusic2APerucussionlɂĎgB


ȂA匳̊֐́@http://f1.aaacafe.ne.jp/~progrm/gba/ 𗬗pĂ܂B


̗́Ả̗̂֏ƃp[JbV̑gݍ킹łB


int main(){
	
	// TEh iKKvj
	InitMusic();

	Music2("T220O5L4 CDEFEDCR EFGAGFER CRCRCRCR L8CCDDEEFF L4EDCR RRRRRRRR");
	Music1("T220O4L4 RRRRRRRR CDEFEDCR EFGAGFER CRCRCRCR L8CCDDEEFF L4EDCR");
	Percussion("T220L4 RBRBRBRB RBRBRBRB8B8 RBRBRBRB RBRBRBRB8B8 RB8B8RBRBBC");

	while(1){
        WaitForVsync();

	}

}


ȂAĐǂ͎̊֐Ŕł
iĐȂ1AȊO0ԂĂjF

---------------------------------------------------------------------------------

Ȃ̃e|
Tn : n  1--255


̒ L
L1@FS
L2@FQ
L3@FRAQiR̒Sj
L4@FS
L6@FRASiR̒Qj
L8@FW
L12@FRAWiR̒Sj
L16@F16
L24@FRA16iR̒Wj
L32@F32
L48@FRA32iR̒16j
L64@F64


K
K O Ŏw肷B
O3 -- O8 g
> 1IN^[uオA< 1IN^[u



CDEFGAB Rixj
V[v C# C+
tbg C-


̕\L
Eɑĉ킷t邱ƂłB
FC4D4E4 = L4CDE
EKɑăsIhgĉ\ƂłB
FC4.@ =  4+W
FC4..  =  4+W+16
ȂAsIh͂Q܂ŏd˂Ďw肷邱ƂłB


{[
V0 -- V15 ܂
ij--ij


F
@0 -- @3
SނIׂ


̌
Q1--S7,Q0
ij--ixj,iȂj


XEB[viMUSIC1 ̂݁j
Sn,m
n  Ԃ 0--7,0 ȗ 0
        iZj--ij
m ͕ὠx 1--7,0
        i傫j--ij
Ȃ }CiXtƉɕω



̑
Xy[XL͖B
ȋL͋xƂĈB


// http://satolab.com/GBA%B3%AB%C8%AF/SOLA.html
*/
